// CryptFilename.cpp

#include "stdafx.h"
#include <malloc.h>


void InitBinKey(char* szPassword, int iPasswordLen = 0);
void NextBinKey();
void FillBinKey(PBYTE pyData=NULL, int iBytes=0);
int CreatePermutTab(PBYTE pbyTab, PBYTE pbyITab, int iSize);
void InjectBinKey3(DWORD dwData1, DWORD dwData2, DWORD dwData3);
DWORD GetNextCryptModA(int iSeedIx, DWORD dwInject);


#define NPERMTABS  5
#define PTBUFFERSIZE 0x450
static BYTE byPTBuffer[PTBUFFERSIZE];
static int iPTBufferIx = 0;
static WORD wPermLut[256];
//									   222222222222233333333333345555677777    44444444444444455555555555    AAAAAAAAAAAAAAAABBBBBBBBBBBBBBBBDDFF    CCCCCCCCCCCCCCCCDDDDDDDDDDDDDD
//								 	   013456789BCDE0123456789BD0BDEF0BCDEF    123456789ABCDEF0123456789A    0123456789ABCDEF0123456789ABCDEF7F7F	 0123456789ABCDEF012345689ABCDE
//                                  { " !#$%&'()+,-.0123456789;=@[]^_`{|}~", "ABCDEFGHIJKLMNOPQRSTUVWXYZ", "", "", (PSTR)NULL };
static PSTR cCharTab[NPERMTABS]   = { " !#$%&'()+,-.0123456789;=@[]^_`{}~",  "ABCDEFGHIJKLMNOPQRSTUVWXYZ", "",    "", (PSTR)NULL };
static int iCharTabLen[PTBUFFERSIZE];
static PBYTE byPermTab[NPERMTABS*2];
static PBYTE byPermITab[NPERMTABS*2];
static BYTE byPermTextTab[256];


int CryptFilename(int iMode, char* szName, char* szPassword, int iLen)
{
    int i, n;
	int iTab, iOffs, iPerm;
	if (!szName || !szName[0])
	{	// Schlsseldaten lschen
		memset(byPermTab, 0, sizeof(byPermTab));
		memset(byPermITab, 0, sizeof(byPermITab));
		return 0;
	}

	if (iLen <= 0) iLen = strlen(szName);
	InitBinKey(szPassword);		// Passwort fr SHA256-Key-Generator NextBinKey()

	if (iPTBufferIx == 0)	// Einmaliges Vorbereiten der Tabellen, die unabhngig vom Passwort sind
	{
		memset(wPermLut, 0xff, 512);
		iPTBufferIx = 0;
		for (iTab=0; iTab<NPERMTABS-1; iTab++)
		{
			n = strlen(cCharTab[iTab]);
			iCharTabLen[iTab] = n;
			BOOL bUpper = (cCharTab[iTab][0] & 0x40) != 0;
			for (iOffs=0; iOffs<n; iOffs++)
			{
				wPermLut[(BYTE)cCharTab[iTab][iOffs]] = iOffs | iTab<<8 | (bUpper? 0x8000:0);
				if (bUpper)
					wPermLut[(BYTE)cCharTab[iTab][iOffs] | 0x20] = iOffs | iTab<<8 | 0xa000;
			}
			byPermTab[iTab] = byPTBuffer+iPTBufferIx, iPTBufferIx += n;
			byPermITab[iTab] = byPTBuffer+iPTBufferIx, iPTBufferIx += n;
			byPermTab[iTab+NPERMTABS] = byPTBuffer+iPTBufferIx, iPTBufferIx += n;
			byPermITab[iTab+NPERMTABS] = byPTBuffer+iPTBufferIx, iPTBufferIx += n;
		}
	}
	for (iTab=0; iTab<NPERMTABS-1; iTab++)
	{
		CreatePermutTab(byPermTab[iTab], byPermITab[iTab], iCharTabLen[iTab]);
		CreatePermutTab(byPermTab[iTab+NPERMTABS], byPermITab[iTab+NPERMTABS], iCharTabLen[iTab]);
	}
	FillBinKey();


	char szPermText[256];
	int iPermTextLen = min(256,iLen);	// bei mehr als 256 Zeichen nur die ersten 256 Zeichen permutieren
	WORD wPerm;
	int ix,il,ixc;
	char cUpr;
	DWORD dwChar, dwSum = 0, dwQSum = 0;
	DWORD dwLast = 0;
	DWORD dwMod = 0;
	int iRep=1;	// 1: Vorwrts und Rckwrts, 0: nur Vorwrts

	// Verschlsseln
	if (iMode & 1)
	{
		for (il=0; il<=iRep; il++)
	  	{
			// il=0: Vorwrts, il=1: Rckwrts
			cUpr = 0;
			dwLast = 0;
			for (ix=0; ix<iLen; ix++)
			{
				ixc = il*(iLen-1) + (1-il-il) * ix;
				wPerm = wPermLut[(BYTE)szName[ixc]];
				if (wPerm == 0xffff)	// Diese Zeichen unverndert lassen
					continue;
				iOffs = wPerm & 0xff;	// Offset auf Abbildungstabelle
				iTab = wPerm>>8 & 0x0f;	// Nummer der Abbildungstabelle
				dwMod = GetNextCryptModA(ix&3|(il<<2), dwLast & 0xdfdf);	// Modifikator der Abbildungstabelle
				i = iTab + (dwMod>>16 & 1)*NPERMTABS;	// Eine von zwei Abbildungstabellen whlen
				iOffs = byPermTab[iTab+(dwMod>>17 & 1)*NPERMTABS][iOffs];	//if (il == 1)

				iOffs = (iOffs + (dwMod&0xff)) % iCharTabLen[iTab];
				iPerm = (byPermTab[i][iOffs] + (dwMod>>8 & 0xff)) % iCharTabLen[iTab];
				dwLast = szName[ixc];
				szName[ixc] = (char)(cCharTab[iTab][iPerm] | wPerm>>10 & (wPerm>>8 ^ dwMod ^ cUpr) & 0x20);
				dwLast |= szName[ixc]<<8;
				cUpr =	(cUpr<<3 | cUpr>>5) ^ cUpr>>2;	// nderung bez. Gro-/Kleinschreibung ber Text verstreuen
				cUpr ^=	(dwLast ^ dwMod) & 0x20;
			}
		}

		// Permutation der Zeichenpositionen (Transposition) vom Inhalt abhngig machen, nicht aber von Position oder Gro-/Kleinschreibung
		for (ixc=0; ixc<iPermTextLen; ixc++)
		{
			dwChar = szName[ixc] & 0xdf;
			dwSum += dwChar;
			dwQSum += dwChar * dwChar;
		}
		InjectBinKey3(iLen, dwSum, dwQSum);
		CreatePermutTab(byPermTextTab, NULL, iPermTextLen);
		memcpy(szPermText, szName, iPermTextLen);
		for (ixc=0; ixc<iPermTextLen; ixc++)
		{
			i = byPermTextTab[ixc];
			szName[i] = szPermText[ixc];
		}
	}

	for (i=0;; i++)
	{	// Verhindern von Leerzeichen und Punkt am Anfang oder Ende nach Verschlsselung
		i = strcspn(szName+i, " .") + i;
		if (i>=iLen) break;

		if (szName[i]==' ') szName[i]='';
		else if (szName[i]=='') szName[i]=' ';
		else if (szName[i]=='.') szName[i]='';
		else if (szName[i]=='') szName[i]='.';
	}

	// Entschlsseln
	if (!(iMode & 1))
	{
		// Permutation der Zeichenpositionen (Transposition) ist vom Inhalt abhngig, nicht aber von Position oder Gro-/Kleinschreibung
		for (ixc=0; ixc<iPermTextLen; ixc++)
		{
			dwChar = szName[ixc] & 0xdf;
			dwSum += dwChar;
			dwQSum += dwChar * dwChar;
		}
		InjectBinKey3(iLen, dwSum, dwQSum);
		CreatePermutTab(byPermTextTab, NULL, iPermTextLen);
		memcpy(szPermText, szName, iPermTextLen);
		for (ixc=0; ixc<iPermTextLen; ixc++)
		{
			i = byPermTextTab[ixc];
			szName[ixc] = szPermText[i];
		}

		for (il=iRep; il>=0; il--)
	  	{
			// il=1: Rckwrts, il=0: Vorwrts
			cUpr = 0;
			dwLast = 0;
			for (ix=0; ix<iLen; ix++)
			{
				ixc = il*(iLen-1) + (1-il-il) * ix;
				wPerm = wPermLut[(BYTE)szName[ixc]];
				if (wPerm == 0xffff)
					continue;
				iOffs = wPerm & 0xff;	// Offset auf Abbildungstabelle
				iTab = wPerm>>8 & 0x0f;	// Nummer der Abbildungstabelle
				dwMod = GetNextCryptModA(ix&3|(il<<2), dwLast & 0xdfdf);  // alternativ
				i = iTab + (dwMod>>16 & 1)*NPERMTABS;	// Eine von zwei Abbildungstabellen whlen

				iOffs = (iOffs + (iCharTabLen[iTab]<<8) - (dwMod>>8 & 0xff)) % iCharTabLen[iTab];
				iPerm = (byPermITab[i][iOffs] + (iCharTabLen[iTab]<<8) - (dwMod & 0xff)) % iCharTabLen[iTab];
				iPerm = byPermITab[iTab+(dwMod>>17 & 1)*NPERMTABS][iPerm];	// il == 1 &&

				dwLast = szName[ixc]<<8;
				szName[ixc] = (char)(cCharTab[iTab][iPerm] | wPerm>>10 & (wPerm>>8 ^ dwMod ^ cUpr) & 0x20);   // | wPerm>>10 & cUpr & 0x20;  // & (wPerm>>8 & 0x20 ^ dwMod & 0x20);
				dwLast |= szName[ixc];
				cUpr =	(cUpr<<3 | cUpr>>5) ^ cUpr>>2;
				cUpr ^=	(dwLast ^ dwMod) & 0x20;
			}
		}
	}
	return 0;
}


