// File7KE.cpp

#include "stdafx.h"
#include <malloc.h>
#include <io.h>

#ifndef uint8
#define uint8  unsigned char
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

typedef struct
{
    uint32 total[2];
    uint32 state[8];
    uint8 buffer[64];
}
sha256_context;

void sha256_starts( sha256_context *ctx );
void sha256_update( sha256_context *ctx, uint8 *input, uint32 length );
void sha256_finish( sha256_context *ctx, uint8 digest[32] );

int CryptBinBlock(int iMode, BYTE* pData, int iLen, char* szPassword, __int64 llBlockCnt=0, __int64 llBlockCntH=0, int iPasswordLen=0);

int iFileError = 0;
static DWORD dwCryptRSeed;
static DWORD dwCryptRCarry;


#define FRISTBLKOFFS  0x30

static DWORD dwFMDefSeed = 0;
static DWORD dwFMDefCarry = 0;
static DWORD dwFMRandBufPerf = 0;
static DWORD dwFMRandBufPerf1 = 0x3bf67a23;
static BOOL bRandomInit = FALSE;
#include <sys/timeb.h>

void FillMemRandom(LPBYTE lpBuffer, int iLen, int iType, int iInit, int iMode, PDWORD pdwSeed, PDWORD pdwCarry)
{
	struct _timeb tTime;
	DWORD dwSeed, dwCarry;
	if (pdwSeed) dwSeed = *pdwSeed;
	else dwSeed = dwFMDefSeed;
	if (pdwCarry) dwCarry = *pdwCarry;
	else dwCarry = dwFMDefCarry;
	int iWords = (iLen * 1 + 3) / 4;
	if (iWords <= 0) return;
	if (dwFMRandBufPerf1 == 1) dwFMRandBufPerf1 = 0x3bf67a23;
	
	DWORD dwMaskRR = 0xffffffff;	// Real Random
	DWORD dwMaskPs = 0xffffffff;	// Pseudo Random
	if (iInit != 0)
	{
		if (iInit >= -1)	//if (iInit != -2)
			dwMaskRR = 0;
		if (iInit > 0 || iInit <= -10)
		{
			dwSeed = iInit;
			dwCarry = 354852551;
			dwMaskRR = 0;
			if (pdwSeed==NULL) bRandomInit = FALSE;
		}
	}
	if (dwSeed == 0 && dwCarry == 0 || iInit == 0 && pdwSeed==NULL && !bRandomInit)
	{
		_ftime(&tTime);
		dwSeed += tTime.time + ((long)tTime.millitm << 16);
		dwCarry = 354852551;
		__asm
		{
			rdtsc			    //Read Time-Stamp Counter EDX:EAX
			mov ebx,eax
			xor eax,dwCarry
			and eax,0x7fffffff
			mov dwCarry,eax // 
			
			and ebx,0x80000000
			xor ebx,edx
			xor dwSeed,ebx
		}
		DWORD dwTCnt = GetTickCount();
		dwFMRandBufPerf += dwTCnt;
		dwFMRandBufPerf1 += (long)tTime.millitm;
		if (pdwSeed==NULL) bRandomInit = TRUE;
	}
	if (dwMaskRR == 0) __asm	// iInit: -2, -1, 1, 2, ...0x7fffffff, -10, -11, ... -0x80000000
	{
		// Multiply-with-carry (MWC) random number generator with b = 2^32 
		// (1) t <- a * x + c  (2) x <- t mod b  (3) c <- (int) (t / b)
		mov ecx,iWords
		mov edi,lpBuffer
		mov ebx,dwSeed
		mov esi,dwCarry
		m0:
		mov eax,2131995753  ;214013   // 2131995753 is not prime.  It is divisible by 3.  http://www.math.com/students/calculators/source/prime-number.htm  2131995763 is prime!
		mul ebx
		add eax,esi
		adc edx,0
		mov esi,edx
		mov ebx,eax
		mov [edi],eax 
		lea edi,[edi+4]
		loop m0
		mov dwSeed,ebx
		mov dwCarry,esi
	}
	else __asm
	{
		// Multiply-with-carry (MWC) random number generator with b = 2^32 
		// (1) t <- a * x + c  (2) x <- t mod b  (3) c <- (int) (t / b)
		mov ecx,iWords
		mov edi,lpBuffer
		mov ebx,dwSeed
		m1:
		mov eax,2131995753  ;214013
		mul ebx
		add eax,dwCarry   ;354852551   ;2531011
		adc edx,0
		mov dwCarry,edx
		mov ebx,eax
		mov esi,eax
		rdtsc			    //Read Time-Stamp Counter EDX:EAX
		inc edx				//Weil anfangs 0 und xor dann wirkungslos und wg. ror dwFMRandBufPerf1 zyklisch mit Periode 32 ist
		xor edx,dwFMRandBufPerf1
		ror edx,5			//ROR - Rotate Right, RCR - Rotate Through Carry Right, ROL - Rotate Left, RCL - Rotate Through Carry Left
		inc edx				//ohne inc: Periode 64 bei dwFMRandBufPerf1 wenn rdtsc EDX=0 liefert
		mov dwFMRandBufPerf1,edx
		xor eax,dwFMRandBufPerf
		add eax,edx
		ror eax,13
		mov dwFMRandBufPerf,eax
		xor eax,edx
		and esi,dwMaskPs		// 0 bei iInit=-3   (0: iInit == -3)
		xor eax,esi
		mov [edi],eax // 
		lea edi,[edi+4]
		loop m1
		mov dwSeed,ebx
	}

	if (pdwSeed) *pdwSeed = dwSeed;
	else dwFMDefSeed = dwSeed;
	if (pdwCarry) *pdwCarry = dwCarry;
	else dwFMDefCarry = dwCarry;
}


int FileCrypt7KE(int iMode, char* szFileIn, char* szFileOut, char* szPassword, double dStartBlock)
{
	// iMode & 0x01:    Verschlsseln statt entschlsseln
	// iMode & 0x20:    Der Schlssel ndert sich von Block zu Block komplett statt nur an einigen Stellen (langsamer)
	// iMode & 0x40:    Zufallswert als erste Blocknummer (auch bei  dStartBlock == -4)
	// iMode & 0x100:	Datum verstecken
	// iMode & 0x200:	Gre nicht verstecken
	// iMode & 0x400:	FILE_FLAG_NO_BUFFERING
	// iMode & 0x800:	Der letze Block ist immer mit der Blocknummer [Blockanzahl - 1] verschlsselt und die Startblocknummer wird im letzten Block gespeichert
	// iMode & 0x1000:	Ist im letzten Block nicht genug Platz fr ntige Zusatzinformationen (Gre, Datum, Startblocknummer), wird die verschlsselte Datei um einen Block vergrert.
	// Schlsselgre:  7280 Bit  ( 4*Gammalog(256+1)/log(2) + 160*2 == ((iKeyCntr-1)*32 + iKeyIx-3)*8 )
    int iErr=0;
	int i, k, n, bytes_read;
	int reached_eof = 0;
    FILE *infp = NULL;
    FILE *outfp = NULL;

	const int iBlockSize = 0x1000;
	BYTE pBuffer[iBlockSize];

	HANDLE hFile;
	union UFT {	unsigned __int64 ull; FILETIME ft; };
	UFT tLastWriteTime;
	tLastWriteTime.ull = 0;
	int iSvMode = 0;
	__int64 llFLen = 0;
	unsigned __int64 ullFirstBlk = 0;
	unsigned __int64 ullFirstBlkH = 0;
	BOOL bFirstBlkFnd = 0;

	BOOL bInPlace = stricmp(szFileIn, szFileOut) == 0;

	hFile = CreateFile(szFileIn, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		ULARGE_INTEGER tFileSize;
		tFileSize.LowPart = GetFileSize(hFile, &tFileSize.HighPart);
		GetFileTime(hFile, NULL, NULL, &tLastWriteTime.ft);
		llFLen = tFileSize.QuadPart;
		if (!(iMode & 1) && (iMode & 0x840 || dStartBlock == -4) && (tFileSize.u.LowPart & 0xfff) == 0 && llFLen > 0)
		{	// letzten Block laden und mit Blocknummer 0 dekodieren, um die Blocknummer des ersten Blocks zu erhalten (zufllige 64-Bit-Zahl)
			tFileSize.QuadPart--;
			SetFilePointer((HANDLE)hFile, tFileSize.LowPart & 0xfffff000, (PLONG)&tFileSize.HighPart, FILE_BEGIN);
			i = ReadFile((HANDLE)hFile, pBuffer, iBlockSize, (PDWORD)&bytes_read, NULL);
			if (i) CryptBinBlock(iMode & 0xfffff021, pBuffer, bytes_read, szPassword, (llFLen-1)>>12);
			if (*(PDWORD)(pBuffer+iBlockSize-0x08) != 0x5324F554) i = 0;
			if (*(PDWORD)(pBuffer+iBlockSize-0x04) != 0x6eb5673c) i = 0;
			tFileSize.QuadPart -= *(__int64*)(pBuffer+iBlockSize-0x10);
			if (tFileSize.HighPart || tFileSize.LowPart > (DWORD)(iBlockSize + FRISTBLKOFFS)) i = 0;
			if (i)
			{
				ullFirstBlk = *(__int64*)(pBuffer+iBlockSize-FRISTBLKOFFS), iMode |= 0x40, dStartBlock = -4;
				if (FRISTBLKOFFS > 0x20) ullFirstBlkH = *(__int64*)(pBuffer+iBlockSize-FRISTBLKOFFS+8), iSvMode = *(int*)(pBuffer+iBlockSize-FRISTBLKOFFS+16);
				bFirstBlkFnd = 1;
			}
		}

		CloseHandle(hFile); 
	}
	__int64 llFLen1 = llFLen;
	__int64 llFCrLen = llFLen;
	int iAddBlock = 0;
	if (iMode & 1)
	{		
		bytes_read = (int)(llFLen % iBlockSize);
		if (!bytes_read) bytes_read = iBlockSize;
		if (iAddBlock)
		{
			AddBlock:
			iAddBlock = 1;
			bytes_read -= iBlockSize;
		}

		if ((llFLen>iBlockSize || !bInPlace) && !(iMode & 0x200))	// (iMode & 0x200): Gre nicht verstecken 
		{
			if (iBlockSize - bytes_read >= (iMode & 0x100? 0x18:0x10))
			{
				llFCrLen = llFLen + (iBlockSize - bytes_read);
				if (iBlockSize - bytes_read >= FRISTBLKOFFS)
				{
					if (iMode & 0x40 || dStartBlock == -4)
					{
						FillMemRandom((BYTE *)&ullFirstBlk, 8, 1, 0, 0, &dwCryptRSeed, &dwCryptRCarry);
						if (FRISTBLKOFFS > 0x20) FillMemRandom((BYTE *)&ullFirstBlkH, 8, 1, 0, 0, &dwCryptRSeed, &dwCryptRCarry);
						if (ullFirstBlk == 0) ullFirstBlk = 0x0123456789abcdef;
						dStartBlock = -4;
					}
				}
				else if (iMode & 0x840 || dStartBlock == -4)
				{
					if (iMode & 0x1000)
						goto AddBlock;
					else if (dStartBlock == -4)
						dStartBlock = -1;
				}
			}
			else if (iMode & 0x1000)
				goto AddBlock;
		}
	}

	unsigned __int64 ullBlk = (unsigned __int64)dStartBlock;
	unsigned __int64 ullBlkH = 0;
	if (dStartBlock < -255)
	{	ullBlk = *(unsigned __int64*)(DWORD)(-dStartBlock);
		if (FRISTBLKOFFS > 0x20) ullBlkH = ((unsigned __int64*)(DWORD)(-dStartBlock))[1];
	}
	else if (iMode & 0x40 && dStartBlock>0) ullBlk = *(unsigned __int64*)(DWORD)dStartBlock;

	if (dStartBlock == -1)
	{
		ullFirstBlk = ullBlk = llFCrLen ^ (llFCrLen<<32);		//| (llFCrLen>>32 & 0xffffffff); 
	}
	else if (dStartBlock == -2 || dStartBlock == -3)
	{
		char* sPh = szFileIn;
		if (!(iMode & 1) ^ (dStartBlock == -3)) sPh = szFileOut;
		n = strlen(sPh);
		for (i=n-1; i>0; i--)
			if (sPh[i] == '\\' || sPh[i] == '/')
				break;
		char* sName = (char*)_alloca(max(n-i,32));
		for (k=0,i++; i<=n; i++, k++)
			sName[k] = tolower(sPh[i]);
		sha256_context shac;
		sha256_starts(&shac);
		sha256_update(&shac, (uint8*)sName, k);
		sha256_update(&shac, (uint8*)&llFCrLen, 8);
		sha256_finish(&shac, (uint8*)sName);
		ullFirstBlk = ullBlk = *(unsigned __int64*)sName;	// nur die ersten 16 Byte vom 32 Byte groen Hash verwenden
		if (FRISTBLKOFFS > 0x20) ullFirstBlkH = ullBlkH = ((unsigned __int64*)sName)[1];
	}
	else if (dStartBlock == -4)
	{
		ullBlk = ullFirstBlk;
		ullBlkH = ullFirstBlkH;
		iMode |= 0x40;
	}
	else if (!bFirstBlkFnd && iMode & 0x800)
	{
		ullFirstBlk = ullBlk;
		ullFirstBlkH = ullBlkH;
	}

	if (bInPlace)
	{
		if ((infp = fopen(szFileIn, "r+b")) == NULL)
		{
			iFileError = 1;
			return iFileError;
		}

		if ((outfp = fopen(szFileIn, "r+b")) == NULL)
		{
			iFileError = 1;
			return iFileError;
		}
	}
	else
	{
		if ((infp = fopen(szFileIn, "rb")) == NULL)
		{
			iFileError = 1;
			return iFileError;
		}

		if ((outfp = fopen(szFileOut, "wb")) == NULL)
		{
			i=fclose(infp);
			iFileError = 2;
			return iFileError;
		}
	}

	DWORD dwBlk = 0;
	unsigned __int64 ullLastBlock = ((llFLen - 1) / iBlockSize) + ullBlk;

	while(!reached_eof)
	{
		if ((bytes_read = (int) fread(pBuffer, 1, 0x1000, infp)) < iBlockSize)
        {
		    if (!feof(infp))
            {
				iErr = 1;				
				break;
            }
			else
            {
			    reached_eof = 1;
				if (iAddBlock)
				{
					memset(pBuffer+bytes_read, 0, iBlockSize - bytes_read);
					if (bytes_read == 0)
						iAddBlock = 0;
					else
						reached_eof = 0, bytes_read = iBlockSize;
				}
				else if (bytes_read == 0)
					break; 
			}
		}

		n = bytes_read;
		if (iMode & 1)
		{
			if (iBlockSize - bytes_read >= 0x10 && !(iMode & 0x200) && (llFLen>iBlockSize || !bInPlace) && iAddBlock==0)	// (iMode & 0x200): Gre nicht verstecken
			{
				//Bei llFLen<iBlockSize und NTFS knnen die Daten direkt beim Verzeichniseintrag stehen. Beim Vergrern auf >= iBlockSize werden diese nicht mehr berschrieben! 
				memset(pBuffer+bytes_read, 0, iBlockSize - bytes_read - 0x10);
				*(PDWORD)(pBuffer+iBlockSize-0x08) = 0x5324F554;
				*(PDWORD)(pBuffer+iBlockSize-0x04) = 0x6eb5673c;
				*(__int64*)(pBuffer+iBlockSize-0x10) = llFLen;
				n = iBlockSize;
				if (iBlockSize - bytes_read >= 0x18)
				{
					*(__int64*)(pBuffer+iBlockSize-0x18) = tLastWriteTime.ull;
					if (iMode & 0x100)	// Datum verstecken
						tLastWriteTime.ull = 0;
				}
				if (iBlockSize - bytes_read >= FRISTBLKOFFS)
				{
					*(__int64*)(pBuffer+iBlockSize-FRISTBLKOFFS) = ullFirstBlk;
				  #if FRISTBLKOFFS==0x30
					*(__int64*)(pBuffer+iBlockSize-0x28) = ullFirstBlkH;
					*(__int64*)(pBuffer+iBlockSize-0x20) = iMode;
				  #endif
					if (iMode & 0x840)
						ullBlk -= ullFirstBlk, ullBlkH = 0;
				}
			}

			CryptBinBlock(iMode & 0xfffff021, pBuffer, n, szPassword, ullBlk, ullBlkH);
		}
		else
		{
			if (ullFirstBlk != 0 && ullBlk == ullLastBlock)
			{
				if (dStartBlock == -4 || iMode & 0x800 && bFirstBlkFnd)
					ullBlk = ullLastBlock = (llFLen-1)>>12,	ullBlkH = 0;	// Der letzte Block erhlt die Blocknummer Blockanzahl - 1
			}

			CryptBinBlock(iMode & 0xfffff021, pBuffer, bytes_read, szPassword, ullBlk, ullBlkH);

			if (ullBlk == ullLastBlock && bytes_read == iBlockSize)
			{
				if ( *(PDWORD)(pBuffer+iBlockSize-0x08) == 0x5324F554 && *(PDWORD)(pBuffer+iBlockSize-0x04) == 0x6eb5673c)
				{
					llFLen1 = *(__int64*)(pBuffer+iBlockSize-0x10);
					if ( (unsigned __int64)(llFLen - llFLen1) < iBlockSize + FRISTBLKOFFS)
						n =  (int)(llFLen1 % iBlockSize);
					else
						llFLen1 = llFLen;
					if (iBlockSize - n >= 0x18 && *(__int64*)(pBuffer+iBlockSize-0x18) != 0)
						tLastWriteTime.ull = *(__int64*)(pBuffer+iBlockSize-0x18);
				}
			}

		}

		if (dwBlk == 0 && !(iMode & 0x20))
			szPassword = "";

		// Write the decrypted block
		if ((i = (int) fwrite(pBuffer, 1, n, outfp)) != n)
		{
			iErr = 1;				
			break;
		}
		if (dwBlk<0xffffffff) dwBlk++;
		ullBlk++;
		if (!ullBlk) ullBlkH++;
	}
    if (fflush(outfp))
    {
		iErr=1;
    }


	i=fclose(infp);
	i=fclose(outfp);

    if (iErr)
    {
		iFileError = 3;
	    if (!bInPlace) unlink(szFileOut);
		return iFileError;
	}
	if (tLastWriteTime.ull || llFLen1 != llFLen || iMode & 0x400)
	{
		DWORD dwFlagsAttrib = FILE_FLAG_BACKUP_SEMANTICS;
		if (iMode & 0x400)  //llFLen1 == llFLen
			dwFlagsAttrib |= FILE_FLAG_NO_BUFFERING;	// Nur Zugriff auf ganze Sektoren mglich
		rep_cf:
		hFile = CreateFile(szFileOut, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, dwFlagsAttrib, 0);
		if (hFile != INVALID_HANDLE_VALUE)
		{
			if (llFLen1 != llFLen)
			{
				long lHOffset=(long)(llFLen1>>32);
				i = SetFilePointer((HANDLE)hFile, (long)(llFLen1 & 0xffffffff), &lHOffset, FILE_BEGIN);
				if (i==-1 && lHOffset == -1)
				{
					if (dwFlagsAttrib & FILE_FLAG_NO_BUFFERING)
					{
						dwFlagsAttrib &= ~FILE_FLAG_NO_BUFFERING;
						CloseHandle(hFile); 
						goto rep_cf;
					}
				}
				i = SetEndOfFile((HANDLE)hFile);
			}
			if (tLastWriteTime.ull)
			{
				i=SetFileTime(hFile, NULL, NULL, &tLastWriteTime.ft);
				if (i==0) iErr=GetLastError();		//Access is denied.  ERROR_ACCESS_DENIED = 5,   The parameter is incorrect.  ERROR_INVALID_PARAMETER = 87
				if (iErr == 0) tLastWriteTime.ull = 0;
			}
			CloseHandle(hFile); 
		}
	}
	return 0;
}

